unit uCharBanks;

interface

procedure SetCharacterBank(value: word);
procedure PresetOppBanks(value: word);
procedure ClearPresets;
procedure SetAltOppColor;

implementation

uses uGlobals, uColortables, uMacFile, uResources;

var
presets: array[0..1] of word;

procedure ClearPresets;
begin
presets[0] := 0;
presets[1] := 0;
end;

procedure SetCharacterBank(value: word);
begin

if ActiveChar.CharType = 0 then
begin
  ActiveChar.ColorOffset := 16;
end
else if ActiveChar.CharType = 6 then
begin
  ActiveChar.ColorOffset := 32;
  PopSetPalette(25008, 32);
  if (currentroom = 6) and (currentlevel.LevelType = 6) then
    ActiveChar.Face := random(2) - 1;
end
else if currentlevel.OpponentType in [0,5,6] then
begin
  PresetOppBanks(value);
end
else
  ActiveChar.ColorOffset := 0;



end;

procedure PresetOppBanks(value: word);
begin
  if currentlevel.OpponentType in [0,5,6] then
  begin
    ActiveChar.ColorOffset := 0;
    if value = 0 then
      value := 1;

      if value = presets[0] then
    ActiveChar.ColorOffset := $20
  else if value = presets[1] then
    ActiveChar.ColorOffset := $30
  else if presets[0] = 0 then
  begin
    ActiveChar.ColorOffset := $20;
    presets[0] := value;
  end
  else if presets[1] = 0 then
  begin
    ActiveChar.ColorOffset := $30;
    presets[1] := value;
  end
  else
    ActiveChar.COlorOffset := $20;


  end
  else if currentlevel.OpponentType = 2 then
    ActiveChar.ColorOffset := $30
  else
    ActiveChar.ColorOffset := $20;

end;


procedure SetAltOppColor;
var
  ctr: Integer;
  curfile: PResFile;
begin
  curfile := PopCurResfile;
  PopUseResFile(resOpp);
  if currentlevel.OpponentType in [0,5,6] then
  begin
    for ctr := 0 to 1 do
    begin
      if presets[ctr] <> 0 then
      begin
        PopSetPalette(749+presets[ctr], $20+ctr*$10);
      end;
    end;
  end
  else if currentlevel.OpponentType = 2 then
  begin
    PopSetPalette(750, $30);
  end;
  PopUseResFile(curfile);
end;

end.
