unit uCompression;

interface

function UnpackLZ(var data:pointer; var srcsize:cardinal):boolean;


implementation

uses uSwapper;

function UnpackLZ(var data:pointer; var srcsize:cardinal):boolean;
var
src:pointer;
destsize: cardinal;
srciter: pbyte;
destiter: pbyte;
temp: pbyte;
destend: pbyte;
magic: word;
tempiter: integer;
stuff: word;
copyoffset: word;
copysize: word;
copyiter: word;
begin
GetMem(src, srcsize);
move(data^, src^, srcsize);
srciter := data;
inc(srciter, 12);
destsize := pcardinal(srciter)^;
destsize := swap4(destsize);
ReallocMem(data, destsize);
inc(srciter, 4);
destiter := pbyte(integer(data) + 12);
temp := AllocMem(1090);
destend := pbyte(integer(data) + destsize);
magic := 0;
tempiter := 958;
while true do
begin

magic := magic shr 1;
if (magic and $100) = 0 then
begin
magic := srciter^ or $FF00;
inc(srciter);
end;

if (magic and 1) = 1 then
begin
  destiter^ := srciter^;
  inc(destiter);
  if destiter = destend then break;

  pbyte(integer(temp) + tempiter)^ := srciter^;
  inc(tempiter);
  tempiter := tempiter and $3FF;
  inc(srciter);
end
else
begin
  stuff := pword(srciter)^;
  stuff := swap2(stuff);
  inc(srciter, 2);
  copyoffset := stuff and $3FF;
  copysize := (stuff shr 10) + 3;
  copyiter := 0;
  if copysize > 0 then
  begin
    repeat
    destiter^ := pbyte(integer(temp) + ((copyiter + copyoffset) and $3FF))^;
    pbyte(integer(temp) + tempiter)^ := destiter^;
    inc(tempiter);
    inc(destiter);
    tempiter := tempiter and $3FF;
    inc(copyiter);
    until (copyiter = copysize) or (integer(destiter) >= integer(destend));
  end;
  if destiter = destend then break;
end;

end;

FreeMem(temp);
FreeMem(src);
pword(data)^ := pword(data)^ and $FFFB;
Result := true;
srcsize := destsize;
end;

end.
