unit uFlames;

interface

procedure SetupShadowFlame;
function IsShadowImbued: boolean;
procedure SaveFChar;
procedure LoadFChar;

implementation

uses uMacTypes, uCellUtil, uObj;

var
  xFCharIdx: smallint;
  xFCharX: smallint;
  xFCharY: smallint;
  xFCharFace: smallint;
  xFColorOffset: word;
  xFCharImg: smallint;
  xFCharset: smallint;
  xFCharBlockTop: smallint;
  xFCharBlockBottom: smallint;
  xFCharBlockLeft: smallint;
  xFCharBlockRight: smallint;
  xFCharClipRect: TMacRect;

  xHandlingRoom: word = 0;
xHandlingCol: smallint = 0;
xHandlingRow: smallint = 0;
xHandlingFore: word = 0;
xHandlingBack: word = 0;
xHandlingCell: smallint;


procedure SetupShadowFlame;
begin
  if not IsShadowImbued then exit;
  SaveFChar;

  LoadFChar;
end;

function IsShadowImbued: boolean;
begin

end;

procedure SaveFChar;
begin
  xFCharIdx:=FCharIdx;
  xFCharX:=FCharX;
  xFCharY:=FCharY;
  xFCharFace:=FCharFace;
  xFColorOffset:=FColorOffset;
  xFCharImg:=FCharImg;
  xFCharset:=FCharset;
  xFCharBlockTop:=FCharBlockTop;
  xFCharBlockBottom:=FCharBlockBottom;
  xFCharBlockLeft:=FCharBlockLeft;
  xFCharBlockRight:=FCharBlockRight;
  xFCharClipRect:=FCharClipRect;

  xHandlingRoom:=HandlingRoom;
xHandlingCol:=HandlingCol;
xHandlingRow:=HandlingRow;
xHandlingFore:=HandlingFore;
xHandlingBack:=HandlingBack;
xHandlingCell:=HandlingCell;

end;

procedure LoadFChar;
begin
  FCharIdx:=xFCharIdx;
  FCharX:=xFCharX;
  FCharY:=xFCharY;
  FCharFace:=xFCharFace;
  FColorOffset:=xFColorOffset;
  FCharImg:=xFCharImg;
  FCharset:=xFCharset;
  FCharBlockTop:=xFCharBlockTop;
  FCharBlockBottom:=xFCharBlockBottom;
  FCharBlockLeft:=xFCharBlockLeft;
  FCharBlockRight:=xFCharBlockRight;
  FCharClipRect:=xFCharClipRect;

  HandlingRoom:=xHandlingRoom;
HandlingCol:=xHandlingCol;
HandlingRow:=xHandlingRow;
HandlingFore:=xHandlingFore;
HandlingBack:=xHandlingBack;
HandlingCell:=xHandlingCell;

end;

end.
