unit uGlobals;

interface
uses uPop2Types, uMacFile, uMacTypes;

var

//resources:
resPrince: PResFile;
resKid: PResFile;
resOpp: PResFile;
levelresources: array [1..6] of PResFile;

basepath: string;
inmap: boolean = false;

DrawingCol: smallint;
DrawingRow: smallint;
DrawingFull: boolean;
DrawingRect: TMacRect;

CurrentForeTable: PForeEntry;
CurrentBackTable: PBackEntry;
CurrentLevel: TLevel;

CurrentRoom: Word;
TopLeftRoom: Word;
TopRoom: Word;
TopRightRoom: Word;
LeftRoom: Word;
RightRoom: Word;
BottomLeftRoom: Word;
BottomRoom: Word;
BottomRightRoom: WOrd;
Customized: boolean;

immediateleft: array [0..2] of TImmediate;
immediateright: array [0..2] of TImmediate;
above: array [0..10] of TImmediate;
below: array [0..10] of TImmediate;

CustomPieces: PCustomPieces;
CustomResource: Pointer;

OS_Fore: word;
OS_Back: TBackPair;
OS_LeftFore: word;
OS_LeftBack: TBackPair;
OS_RightFore: word;
OS_RightBack: TBackPair;

shapesets: array[0..4] of PShapeList;
flameshapes: array of pointer;
horseshape: pointer;

BackBuffer: record
Buffer: pbyte;
SecondBuffer: pbyte;
SecondOffset: pbyte;
SecondValue: byte;
Pitch: Cardinal;
Width: Cardinal;
Height: Cardinal;
Rect: TMacRect;
ClipRect: TMacRect;
end;

CurrentKIdAfrm: smallint;

KidFrames: array of TFrameEntry;
KidAFrames: array of TAFrameEntry;

OppFrames: array of TFrameEntry;
OppAFrames: array of TAFrameEntry;

CharFrame: TFrameEntry;
CharAFrame: TAFrameEntry;

HeadMoves: array of THeadMove;

Kid: TCharInfos;
Shads: array [0..4] of TCharInfos;
ActiveChar: TCharInfos;
ActiveOpp: TCharInfos;

CurrentFrame: TFrameEntry;
CurrentAFrame: TAFrameEntry;

CurrentOppType: smallint = -1;

SwordType: smallint;

carpetshapes: array[0..9] of pointer;

opppath: array [0..10] of string = (
'Data\Guard.rsrc',
'Data\FlameSword.rsrc',
'Data\Skeleton.rsrc',
'',
'',
'Data\Head.rsrc',
'',
'Data\BirdHead.rsrc',
'Data\Head.rsrc',
'Data\Jinnee.rsrc',
'');

implementation

initialization

finalization
  if horseshape <> nil then
    FreeMem(horseshape);

end.
