unit uOpponents;

interface

uses uPop2Types;

function SkelAddOpponent(guard: PStaticGuard):PStaticGuard;
function HeadAddOpponent(guard: PStaticGuard):PStaticGuard;
procedure CheckSideRoomsForVisibleOpps;

implementation

uses uGlobals, uCellUtil, uChars;

function SkelAddOpponent(guard: PStaticGuard):PStaticGuard;
var
dist: smallint;
begin
if guard^.m_1C = 1 then
begin
  guard^.Seq := 63;
  ActiveChar.Sword := 1;
end
else
begin
  if (ActiveChar.Index = 0) and (guard^.m_1C = 0) then
    guard^.Seq := 112
  else
    guard^.Seq := 119;
  guard^.m_1E := guard^.m_1C;
  //SetSkelShakes(ActiveChar.Index);
  ActiveChar.Sword := 0;
  if ((ActiveChar.Face = -1) and IsSpace(GetCellsInFront(1))) or
  ((ActiveChar.Face = 0) and IsSpace(GetFirstCellInBack)) then
  begin
    dist := GetDist;
    if ActiveChar.Face = 0 then
      dist := 51 - dist;
    if dist <= 54 then
    begin
      dist := 54 - dist;
      if ActiveChar.Face = -1 then
        dist := -dist;
      ActiveChar.X := AddCharX(dist);
      
    end;
  end;
  guard^.SeqPos := 0;
  ActiveChar.ColorOffset := 0;
end;

Result := guard;
end;

function HeadAddOpponent(guard: PStaticGuard):PStaticGuard;
begin
  if guard^.GuardType = 0 then
  begin
    guard^.GuardType := 5;
    ActiveChar.CharType := 7;
    ComputeCharY;
  end;
  if ActiveChar.CharType = $B then
  begin
    if ActiveChar.Death < 0 then
    begin
      if guard^.m_1C <= 0 then
      begin
        guard^.Seq := 170;
        guard^.SeqPos := 0;
        guard^.m_1C := -1;
      end
      else
      begin
        guard^.Seq := 175;
        guard^.SeqPos := 0;
        ActiveChar.Status := 6;
      end;
      ActiveChar.Sword := 1;
      //AddSound(128)
    end
    else
    begin
      ActiveChar.Sword := 0;
    end;
  end
  else
  begin
    ActiveChar.X := ActiveChar.BlockX * 51 + $FE;
    ActiveChar.Face := -1;
    guard^.Seq := 130;
    guard^.SeqPos := 0;
    guard^.Sword := 0;
    guard^.m_1C := 0;
  end;
  Result := guard;
end;

procedure CheckSideRoomsForVisibleOpps;
var
  ctr: Integer;
  theroom: word;
  thisroom: PRoomGuard;
  thatroom: PRoomGuard;
  guardidx: integer;
  theopp: integer;
  ctr2: Integer;
begin
  thisroom := @currentlevel.roomguards[currentroom -1];
  for ctr := 0 to 1 do
  begin
    if ctr=0 then
    begin
      theroom := leftroom;
      theopp := -510;
    end
    else
    begin
      theroom := rightroom;
      theopp := 510;
    end;
    if theroom<>0 then
    begin
      thatroom := @currentlevel.roomguards[theroom -1];
      guardidx := 0;
      while (thisroom^.Count < 5) and (guardidx < thatroom^.Count) do
      begin
        if ((ctr = 0) and (thatroom^.Guards[guardidx].Left > $249)) or
        ((ctr = 1) and (thatroom^.Guards[guardidx].Left < $14B)) then
        begin
          thisroom^.Guards[thisroom^.Count] := thatroom^.Guards[guardidx];
          inc(thisroom^.Guards[thisroom^.Count].Left, theopp);
          for ctr2 := guardidx to 3 do
            thatroom^.Guards[ctr2] := thatroom^.Guards[ctr2+1];
          dec(thatroom^.Count);
          dec(guardidx);
          inc(thisroom^.Count);
        end;
        inc(guardidx);
      end;


    end;
  end;
end;

end.
