unit uDesert;

interface

procedure DrawDoor;
procedure DrawRock;
procedure DrawPlank;
procedure DrawSinkable;

implementation

uses uPop2Types, uScreen, uImgTables, uGlobals, uMacTypes;

procedure DrawDoor;
var
masked: word;
oldclip: TMacRect;
begin
  if (NextBFItem^.layer <> 11) or (drawingcol <> NextBFItem^.col) then exit;
  masked := NextBFItem^.PartBack.Back1 and $1F;
  if masked <> 0 then
  begin
    oldclip := drawingrect;
    drawingrect := backbuffer.rect;
  end;
  custompieces^.Content[2].left := 13 - masked * 3;
  custompieces^.Content[16].left := 41 - masked * 3;

  //13 - masked * 3    -> $62
  //41 - masked * 3    -> $222
  //0                  -> $230
  DrawCustomRoomImg(2, 11);
  DrawCustomRoomImg(16, 11);
  if masked <> 0 then
  begin
    drawingrect := oldclip;
  end;
end;

procedure DrawRock;
var
masked: word;
oldclip: TMacRect;
begin
  if NextBFItem^.Layer <> 11 then exit;
  masked := (NextBFItem^.PartBack.Back1 and $F);
  oldclip := drawingrect;
  drawingrect := backbuffer.rect;
  DrawCustomRoomImg((masked shr 1) + 2, 11);
  drawingrect := oldclip;
end;

procedure DrawPlank;
var
masked: word;
oldclip: TMacRect;
begin
  if NextBFItem^.Layer <> 11 then exit;
  masked := (NextBFItem^.PartBack.Back1 and $F);
  oldclip := drawingrect;
  drawingrect := backbuffer.rect;
  DrawCustomRoomImg((masked shr 1) + 1, 11);
  drawingrect := oldclip;
end;

procedure DrawSinkable;
var
masked: word;
begin
  if not (NextBFItem^.Layer in [2,11]) then exit;
  masked := (NextBFItem^.PartBack.Back1 and $F);
  if masked = 0 then exit;
  DrawCustomRoomImgAtInfo(2+masked);
  //le reste concerne le symbole.
end;

end.
