unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShlObj;

type
  TForm3 = class(TForm)
    Edit1: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    btnLevel: TButton;
    Image31: TImage;
    Image32: TImage;
    Image33: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    Image37: TImage;
    Image38: TImage;
    Image39: TImage;
    Image40: TImage;
    btnLoadFolder: TButton;
    btnLeft: TButton;
    btnUp: TButton;
    btnRight: TButton;
    btnDown: TButton;
    Button7: TButton;
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnLevelClick(Sender: TObject);
    procedure btnLoadFolderClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
    procedure btnLeftClick(Sender: TObject);
    procedure btnRightClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
    procedure DrawBuffer(buftype: byte);
    procedure DrawCurrentRoom;
    procedure CheckNav;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

uses uColorTables, uShapes, uMacFile, uResources, uSwapper, uLevel, uGlobals, uPop2Types, uFrames,
uScreen, uRoomUtil, uCustom, uImgTables, uDrawBF, uChars, uObj, uCharBanks, {pngimage,} uSHared
;

function foldermsg(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
var
apppath: string;
foldername: pchar;
begin
apppath := ExtractFilePath(ExpandFileName(application.ExeName));
  case uMsg of
    BFFM_INITIALIZED:
    SendMessage(wnd, BFFM_SETSELECTION, 1, integer(pchar(apppath)));
    BFFM_SELCHANGED:
    begin
      foldername := stralloc(MAX_PATH);
      if SHGetPathFromIDList(PItemIDList(lparam), foldername) then
        SendMessage(wnd, BFFM_SETSTATUSTEXT, 0, integer(foldername));
      Strdispose(foldername);

    end;
  end;
  Result := 0;
end;

function manualfolder: boolean;
var
  brinfo: BROWSEINFO;
  foldername: pchar;
  basepath: PItemIDList;
  userpath: PItemIDList;
  strname: string;
  notry: boolean;
begin
  Result := false;
  foldername := StrAlloc(MAX_PATH);
  SHGetSpecialFolderLocation(0, CSIDL_DRIVES, basepath);
  brinfo.hwndOwner := 0;
  brinfo.pidlRoot := basepath;
  brinfo.pszDisplayName := foldername;
  brinfo.lpszTitle := 'Please select the folder containing the Prince of Persia 2 files';
  brinfo.ulFlags := BIF_USENEWUI or BIF_NONEWFOLDERBUTTON;
  brinfo.lpfn := foldermsg;
  notry := false;
  repeat
    userpath := SHBrowseForFolder(brinfo);
    if userpath <> nil then
    begin
      if SHGetPathFromIDList(userpath, foldername) then
      begin
        strname := foldername;
        if FileExists(strname + '\Data\Prince.rsrc') and FileExists(strname + '\Data\Kid.rsrc') then
        begin
          uGlobals.basepath := strname + '\';
          Result := true;
          break;
        end;
      end;
    end
    else
      notry := true;

  until notry;
  strdispose(foldername);

end;


procedure TForm3.btnDownClick(Sender: TObject);
begin
currentroom := bottomroom;
DrawCurrentRoom;
CheckNav;
end;

procedure TForm3.btnLeftClick(Sender: TObject);
begin
if (currentlevel.LevelNumber=14) and (currentroom=2) then
currentroom := 11
else if (currentlevel.LevelNumber=6) and (currentroom=27) then
currentroom := 3
else
currentroom := leftroom;

DrawCurrentRoom;
CheckNav;

end;

procedure TForm3.btnRightClick(Sender: TObject);
begin
if (currentlevel.levelnumber=14) and (currentroom=11) then
  currentroom := 2
else
  currentroom := rightroom;
DrawCurrentRoom;
CheckNav;

end;

procedure TForm3.btnUpClick(Sender: TObject);
begin
currentroom := toproom;
DrawCurrentRoom;
checknav;
end;

var
res: PResFile = nil;

procedure TForm3.Button4Click(Sender: TObject);
var
bmp:TBitmap;
  ctr: Integer;
  ctr1: integer;
rowiter: pbyte;
cur: PResFile;
  ctr3: Integer;
//ligne: string;
//lignes: TStringList;
begin

//currentroom := 16;

{
lignes := TStringList.Create;
for ctr := 0 to currentlevel.MaxRooms - 1 do
begin
  for ctr2 := 0 to 29 do
  begin
    ligne := inttostr(ctr+1) + '_'+inttostr(ctr2) + ':';
    case currentlevel.ForeTables[ctr][ctr2] of
    CELL_SPIKES: ligne := ligne + 'Spikes';
    CELL_DOOR: ligne := ligne + 'Door';
    CELL_RAISED: begin
    ligne := ligne + 'UpPlate';
    downlink := currentlevel.backtables[ctr][ctr2].back1 and $FF;
    while downlink >= 0 do
    begin
      ligne := ligne + ' ' + inttostr(currentlevel.links[downlink].room) + '_' + inttostr(currentlevel.links[downlink].cell);
      downlink := currentlevel.links[downlink].next;
    end;
    end;
    CELL_LOWERED: begin
    ligne := ligne + 'DownPlate';
    downlink := currentlevel.backtables[ctr][ctr2].back1 and $FF;
    while downlink >= 0 do
    begin
      ligne := ligne + ' ' + inttostr(currentlevel.links[downlink].room) + '_' + inttostr(currentlevel.links[downlink].cell);
      downlink := currentlevel.links[downlink].next;
    end;
    end;
    CELL_TUNNEL: ligne := ligne + 'Crevice';
    CELL_POTION: begin
     ligne := ligne + 'Potion';
     ligne := ligne + ' $' + inttohex(ushared.GetFlaskBubbleColor(currentlevel.backtables[ctr][ctr2].Back1),2) + ' (' + inttohex(currentlevel.backtables[ctr][ctr2].Back1 and $E0,2) + ')';
    end;
    CELL_LOOSE: ligne := ligne + 'Loose';
    CELL_SLICERLEFT: ligne := ligne + 'Scythe1';
    CELL_SLICERRIGHT: ligne := ligne + 'Scythe2';
    CELL_DEBRIS: ligne := ligne + 'Rubble';
    CELL_DROP: ligne := ligne + 'Drop';
    CELL_EXITLEFT: ligne := ligne + 'Exit1';
    CELL_EXITRIGHT: ligne := ligne + 'Exit2';
    CELL_SLIDEWALL: ligne := ligne + 'SlidingRock';
    CELL_FLIP: ligne := ligne + 'TrapDoor';
    CELL_DART: ligne := ligne + 'Dart';
    CELL_PRESSURE: begin
    ligne := ligne + 'Pressure';
    downlink := currentlevel.backtables[ctr][ctr2].back1 and $FF;
    while downlink >= 0 do
    begin
      ligne := ligne + ' ' + inttostr(currentlevel.links[downlink].room) + '_' + inttostr(currentlevel.links[downlink].cell);
      downlink := currentlevel.links[downlink].next;
    end;
    end;
    else
    ligne := '';
    end;
    if ligne <> '' then
    lignes.add(ligne);
  end;
end;
lignes.SaveToFile(basepath + 'contenu_'+inttostr(currentlevel.LevelNumber)+'.txt');
lignes.Free;

exit;
}
inmap := true;
for ctr3 := 0 to 1 do
begin

for ctr1 := 1 to currentlevel.MaxRooms do
begin
    //ferme les tunnels.
  for ctr := 0 to 29 do
  begin
    if currentlevel.ForeTables[ctr1-1][ctr] = 7 then
    begin
      if ctr3 = 1 then
      currentlevel.backtables[ctr1-1][ctr].Back1 := currentlevel.backtables[ctr1-1][ctr].Back1 or $80
      else
      currentlevel.backtables[ctr1-1][ctr].Back1 := currentlevel.backtables[ctr1-1][ctr].Back1 and $FF7F;

    end;

  end;

end;

for ctr1 := 1 to currentlevel.MaxRooms do
begin
  currentroom := ctr1;

ClearPresets;


PopUseResFile(levelresources[currentlevel.LevelType]);
SetRoomPalette(currentlevel.LevelType);
//PopUseResFile(cur);

MapSurroundingRooms;
LoadCustomRoomData(currentroom);
drawingfull := true;

SetKidInitial;
SetShadInitial;

DoSure;
//drawingfull := false;
//backgroundhidden := false;
//ClearBackTable;
//DoFast;
//DrawCustomRoomImg;


if currentlevel.InitialRoom = currentroom then
begin
  LoadKid;
  SetupKid;
end;

Opponent1;

DrawObjs;


DumpTables;

SetAltOppColor;

bmp := TBitmap.Create;
bmp.PixelFormat := pf8bit;
bmp.Palette := uColorTables.GetPalette;

bmp.SetSize(backbuffer.Width, backbuffer.Height);
rowiter := backbuffer.buffer;
for ctr := 0 to backbuffer.height - 1 do
begin
  move(rowiter^,bmp.scanline[ctr]^, backbuffer.width);
  inc(rowiter, backbuffer.pitch);
end;


ForceDirectories(basepath + 'screens\');
bmp.SaveToFile(basepath + 'screens\' + inttostr(currentlevel.levelnumber) + '_' + inttostr(ctr1) +'_t' + inttostr(ctr3) + '.bmp');

bmp.Palette := uColorTables.GetBWPalette;

rowiter := backbuffer.secondbuffer;
for ctr := 0 to backbuffer.height - 1 do
begin
  move(rowiter^,bmp.scanline[ctr]^, backbuffer.width);
  inc(rowiter, backbuffer.pitch);
end;

ForceDirectories(basepath + 'masks\');
bmp.SaveToFile(basepath + 'masks\' + inttostr(currentlevel.levelnumber) + '_' + inttostr(ctr1) +'_t' + inttostr(ctr3) + '.bmp');


bmp.Free;

end;
end;
inmap := false;
end;

procedure TForm3.Button5Click(Sender: TObject);
{
var
png: TPngObject;
fs: TFileStream;
bmp: TBitmap;
ysize: byte;
xsize: byte;
fakebmp: TBitmap;
  ctr: Integer;
  ctr2: Integer;
  idx: byte;
  ypos, xpos: integer;
  ctr3: Integer;
  srcpix: pbyte;
  destpix: pbyte;
  ctr4: Integer;
}
begin
{
fs := TFileStream.Create(basepath + 'map_' + inttostr(currentlevel.levelnumber) + '.bin', fmOpenRead);
fs.Read(ysize, 1);
fs.read(xsize, 1);

fakebmp := TBitmap.Create;
fakebmp.SetSize(xsize * 510, ysize * 360 + 5);
fakebmp.PixelFormat := pf24bit;
for ctr := 0 to fakebmp.height - 1 do
  Fillchar(fakebmp.scanline[ctr]^, fakebmp.Width * 3, 0); //noir

png := TPngObject.Create;
png.Assign(fakebmp);
png.CreateAlpha;
for ctr := 0 to png.Height - 1 do
fillchar(png.alphascanline[ctr]^,png.Width, 0); //et transparent.


for ctr := 0 to ysize - 1 do
begin
  for ctr2 := 0 to xsize - 1 do
  begin
    fs.Read(idx, 1);
    if idx > 0 then
    begin
      bmp := TBitmap.Create;
      bmp.LoadFromFile(basepath + edit3.text + 's\'+edit4.text+'_'+inttostr(idx)+'_t0.bmp');

      ypos := 360 * ctr;
      xpos := 510 * ctr2;

      //alpha
      for ctr3 := 0 to bmp.height - 1 do
      begin
        srcpix := bmp.ScanLine[ctr3];
        destpix := pbyte(png.alphaScanLine[ctr3+ypos]);
        inc(destpix, xpos); //vers la bonne place.
        for ctr4 := 0 to bmp.width - 1 do
        begin
          if srcpix^<>0 then
            destpix^ := 255;
          inc(srcpix);
          inc(destpix);
        end;
      end;

      //le reste.
      bmp.PixelFormat := pf24bit;

      for ctr3 := 0 to bmp.height - 1 do
      begin
        srcpix := bmp.ScanLine[ctr3];
        destpix := png.Scanline[ctr3+ypos];
        inc(destpix, xpos * 3);
        move(srcpix^,destpix^,bmp.Width*3);
      end;

      bmp.free;

    end;
  end;
end;
png.SaveToFile(basepath + 'big' + edit3.text + '_'+edit4.text+'.png');

png.Free;
fakebmp.free;
fs.free;
}
end;

procedure TForm3.Button6Click(Sender: TObject);
var
  ctr: Integer;
begin
for ctr := 1 to 14 do
begin
  edit4.text := inttostr(ctr);
  button5.Click;
end;

end;

procedure TForm3.Button7Click(Sender: TObject);
var
ctr: integer;
ctr2: integer;
links: array [0..63] of array [0..63] of shortint;
linked: word;
uplink: word;
downlink: word;
leftlink: word;
rightlink: word;
canlinkmore: boolean;
fs: TFileStream;
val: shortint;
begin
for ctr := 0 to 63 do
  for ctr2 := 0 to 63 do
    links[ctr][ctr2] := -1;

linked := 1;
uplink := 31;
downlink := 31;
leftlink := 31;
rightlink := 31;

links[31][31] := currentlevel.InitialRoom;
canlinkmore := true;
while canlinkmore do
begin
  canlinkmore := false;
  for ctr := 0 to 63 do
  begin
    for ctr2 := 0 to 63 do
    begin
      if links[ctr][ctr2] > 0 then
      begin
        if links[ctr-1][ctr2] = -1 then
        begin
          canlinkmore := true;
          links[ctr -1][ctr2] := currentlevel.relations[links[ctr][ctr2]-1].Up;
          if (links[ctr -1][ctr2] > 0) and (uplink>(ctr-1)) then
            uplink := ctr-1;
        end;
        if links[ctr+1][ctr2] = -1 then
        begin
          canlinkmore := true;
          links[ctr +1][ctr2] := currentlevel.relations[links[ctr][ctr2]-1].Down;
          if (links[ctr +1][ctr2] > 0) and (downlink<(ctr+1)) then
            downlink := ctr+1;
        end;

        if links[ctr][ctr2-1] = -1 then
        begin
          canlinkmore := true;
          links[ctr][ctr2-1] := currentlevel.relations[links[ctr][ctr2]-1].Left;
          if (links[ctr][ctr2-1] > 0) and (leftlink>(ctr2-1)) then
            leftlink := ctr2-1;
        end;

        if links[ctr][ctr2+1] = -1 then
        begin
          canlinkmore := true;
          links[ctr][ctr2+1] := currentlevel.relations[links[ctr][ctr2]-1].Right;
          if (links[ctr][ctr2+1] > 0) and (rightlink<(ctr2+1)) then
            rightlink := ctr2+1;
        end;
      end;
    end;
  end;
end;


fs := TFileStream.Create(basepath + 'map_' + inttostr(currentlevel.LevelNumber) + '.bin', fmCreate);
val := downlink - uplink + 1;
fs.Write(val,1);
val := rightlink - leftlink + 1;
fs.write(val,1);
for ctr := uplink to downlink do
begin
  for ctr2 := leftlink to rightlink do
  begin
    val := links[ctr][ctr2];
    if val < 0 then val := 0;
    fs.Write(val, 1);
  end;
end;
fs.free;
end;

procedure TForm3.btnLevelClick(Sender: TObject);
var
  ctr: Integer;
  ctr1: integer;
lnum: integer;
begin

if not trystrtoint(edit4.Text, lnum) then exit;
if (lnum<1) or (lnum>14) then exit;

PopUseResFile(resKid);

LoadLevel(lnum);

for ctr1 := 1 to currentlevel.MaxRooms do
begin
    //close tunnels.
  for ctr := 0 to 29 do
  begin
    if currentlevel.ForeTables[ctr1-1][ctr] = 7 then
      currentlevel.backtables[ctr1-1][ctr].Back1 := currentlevel.backtables[ctr1-1][ctr].Back1 and $FF7F;
   end;
end;


  currentroom := currentlevel.InitialRoom;
CheckNav;

DrawCurrentRoom;

end;

procedure TForm3.btnLoadFolderClick(Sender: TObject);
begin
  if not manualfolder then exit;
  edit1.text := basepath;
  

  resPrince := OpenResFile(basepath + 'Data\Prince.rsrc');
  resKid := OpenResFile(basepath + 'Data\Kid.rsrc');
  levelresources[1] := OpenResFile(basepath + 'Data\Desert.rsrc');
  levelresources[2] := OpenResFile(basepath + 'Data\Temple.rsrc');
  levelresources[3] := OpenResFile(basepath + 'Data\Caverns.rsrc');
  levelresources[4] := OpenResFile(basepath + 'Data\Ruins.rsrc');
  levelresources[5] := OpenResFile(basepath + 'Data\Rooftops.rsrc');
  levelresources[6] := OpenResFile(basepath + 'Data\Final.rsrc');

end;

procedure TForm3.FormCreate(Sender: TObject);
begin
//ReportMemoryLeaksOnShutDown := true;
Randomize;
CreateBackBuffer;
SetupPalette;
image1.Canvas.FillRect(rect(0,0,51,120));
image2.Canvas.FillRect(rect(0,0,51,120));
image3.Canvas.FillRect(rect(0,0,51,120));
image4.Canvas.FillRect(rect(0,0,51,120));
image5.Canvas.FillRect(rect(0,0,51,120));
image6.Canvas.FillRect(rect(0,0,51,120));
image7.Canvas.FillRect(rect(0,0,51,120));
image8.Canvas.FillRect(rect(0,0,51,120));
image9.Canvas.FillRect(rect(0,0,51,120));
image10.Canvas.FillRect(rect(0,0,51,120));
image11.Canvas.FillRect(rect(0,0,51,120));
image12.Canvas.FillRect(rect(0,0,51,120));
image13.Canvas.FillRect(rect(0,0,51,120));
image14.Canvas.FillRect(rect(0,0,51,120));
image15.Canvas.FillRect(rect(0,0,51,120));
image16.Canvas.FillRect(rect(0,0,51,120));
image17.Canvas.FillRect(rect(0,0,51,120));
image18.Canvas.FillRect(rect(0,0,51,120));
image19.Canvas.FillRect(rect(0,0,51,120));
image20.Canvas.FillRect(rect(0,0,51,120));
image21.Canvas.FillRect(rect(0,0,51,120));
image22.Canvas.FillRect(rect(0,0,51,120));
image23.Canvas.FillRect(rect(0,0,51,120));
image24.Canvas.FillRect(rect(0,0,51,120));
image25.Canvas.FillRect(rect(0,0,51,120));
image26.Canvas.FillRect(rect(0,0,51,120));
image27.Canvas.FillRect(rect(0,0,51,120));
image28.Canvas.FillRect(rect(0,0,51,120));
image29.Canvas.FillRect(rect(0,0,51,120));
image30.Canvas.FillRect(rect(0,0,51,120));
image31.Canvas.FillRect(rect(0,0,51,120));
image32.Canvas.FillRect(rect(0,0,51,120));
image33.Canvas.FillRect(rect(0,0,51,120));
image34.Canvas.FillRect(rect(0,0,51,120));
image35.Canvas.FillRect(rect(0,0,51,120));
image36.Canvas.FillRect(rect(0,0,51,120));
image37.Canvas.FillRect(rect(0,0,51,120));
image38.Canvas.FillRect(rect(0,0,51,120));
image39.Canvas.FillRect(rect(0,0,51,120));
image40.Canvas.FillRect(rect(0,0,51,120));
end;

procedure TForm3.DrawBuffer(buftype: byte);
var
bmp: TBitmap;
rowiter: pbyte;
ctr: integer;
begin
bmp := TBitmap.Create;
bmp.PixelFormat := pf8bit;
if buftype = 0 then
  bmp.Palette := uColorTables.GetPalette
else
  bmp.Palette := uColorTables.GetBWPalette;

bmp.SetSize(backbuffer.Width, backbuffer.Height);
if buftype = 0 then
  rowiter := backbuffer.buffer
else
  rowiter := backbuffer.SecondBuffer;
for ctr := 0 to backbuffer.height - 1 do
begin
  move(rowiter^,bmp.scanline[ctr]^, backbuffer.width);
  inc(rowiter, backbuffer.pitch);
end;

image1.Canvas.Draw(0,-5,bmp);
image2.Canvas.Draw(-51,-5,bmp);
image3.Canvas.Draw(-102,-5,bmp);
image4.Canvas.Draw(-153,-5,bmp);
image5.Canvas.Draw(-204,-5,bmp);
image6.Canvas.Draw(-255,-5,bmp);
image7.Canvas.Draw(-306,-5,bmp);
image8.Canvas.Draw(-357,-5,bmp);
image9.Canvas.Draw(-408,-5,bmp);
image10.Canvas.Draw(-459,-5,bmp);

image11.Canvas.Draw(0,-125,bmp);
image12.Canvas.Draw(-51,-125,bmp);
image13.Canvas.Draw(-102,-125,bmp);
image14.Canvas.Draw(-153,-125,bmp);
image15.Canvas.Draw(-204,-125,bmp);
image16.Canvas.Draw(-255,-125,bmp);
image17.Canvas.Draw(-306,-125,bmp);
image18.Canvas.Draw(-357,-125,bmp);
image19.Canvas.Draw(-408,-125,bmp);
image20.Canvas.Draw(-459,-125,bmp);

image21.Canvas.Draw(0,-245,bmp);
image22.Canvas.Draw(-51,-245,bmp);
image23.Canvas.Draw(-102,-245,bmp);
image24.Canvas.Draw(-153,-245,bmp);
image25.Canvas.Draw(-204,-245,bmp);
image26.Canvas.Draw(-255,-245,bmp);
image27.Canvas.Draw(-306,-245,bmp);
image28.Canvas.Draw(-357,-245,bmp);
image29.Canvas.Draw(-408,-245,bmp);
image30.Canvas.Draw(-459,-245,bmp);

image31.Canvas.Draw(0,0,bmp);
image32.Canvas.Draw(-51,0,bmp);
image33.Canvas.Draw(-102,0,bmp);
image34.Canvas.Draw(-153,0,bmp);
image35.Canvas.Draw(-204,0,bmp);
image36.Canvas.Draw(-255,0,bmp);
image37.Canvas.Draw(-306,0,bmp);
image38.Canvas.Draw(-357,0,bmp);
image39.Canvas.Draw(-408,0,bmp);
image40.Canvas.Draw(-459,0,bmp);


bmp.Free;

end;

procedure TForm3.FormDestroy(Sender: TObject);
begin

UnloadLevel(0);
DeInitPalette;
DestroyBackBuffer;

CloseResFile(resPrince);
CloseResFile(resKid);
CloseResFile(levelresources[1]);
CloseResFile(levelresources[2]);
CloseResFile(levelresources[3]);
CloseResFile(levelresources[4]);
CloseResFile(levelresources[5]);
CloseResFile(levelresources[6]);
end;

procedure TForm3.DrawCurrentRoom;
var
cur: PResFile;
begin
ClearPresets;

PopUseResFile(levelresources[currentlevel.LevelType]);
SetRoomPalette(currentlevel.LevelType);

MapSurroundingRooms;
LoadCustomRoomData(currentroom);
drawingfull := true;

SetKidInitial;
SetShadInitial;

DoSure;

if currentlevel.InitialRoom = currentroom then
begin
  LoadKid;
  SetupKid;
end;

Opponent1;

DrawObjs;


DumpTables;

SetAltOppColor;

DrawBuffer(0);
end;

procedure TForm3.CheckNav;
begin
  btnUp.enabled := currentlevel.Relations[currentroom-1].Up <> 0;
  btnDown.enabled := currentlevel.Relations[currentroom-1].Down <> 0;
  btnLeft.enabled := currentlevel.Relations[currentroom-1].Left <> 0;
  btnRight.enabled := currentlevel.Relations[currentroom-1].Right <> 0;
  if (currentlevel.LevelNumber = 14) then
  begin
    if currentroom = 1 then
      btnUp.Enabled := false;
    if currentroom = 2 then
      btnleft.Enabled := true;
    if currentroom = 11 then
      btnRight.Enabled := true;
    if currentroom = 3 then
      btnDown.Enabled := false;
  end;
end;

end.
