unit uObj;

interface

uses uPop2Types, uMacTypes;

function LoadObject(index: word): smallint;
procedure DrawObj(index: word);
procedure DrawObjs;
procedure ClearObjTable;

var
ObjCount: integer;
ObjList: array [0..29] of TObj;

  FCharIdx: smallint;
  FCharX: smallint;
  FCharY: smallint;
  FCharFace: smallint;
  FColorOffset: word;
  FCharImg: smallint;
  FCharset: smallint;
  FCharBlockTop: smallint;
  FCharBlockBottom: smallint;
  FCharBlockLeft: smallint;
  FCharBlockRight: smallint;
  FCharClipRect: TMacRect;

implementation

uses uImgTables;

function LoadObject(index: word): smallint;
begin
  with ObjList[index] do
  begin
    FCharIdx := Idx;
    FCharX := X;
    FCharY := Y;
    FCharImg := ImgID;
    FCharSet := ImgSet;
    FCharFace := Face;
    FCharClipRect := Rect;
    FColorOffset := ColorOffset;
    Result := ObjType;
  end;
end;

procedure DrawObj(index: word);
begin
  case LoadObject(index) of
  0: begin
    //kid
    if FCharImg = -1 then exit;
    if not AddMid(FCharSet, FCharImg+1, FCharX, FCharY, $10) then exit;
    if FColorOffset = 0 then exit;
    MidImgTable1[MidImgCount1-1].ColorOffset := FColorOffset;
  end;
  1,2,3,4,5,6,7,8,9,$A,$E: begin
    //baddies
    if FCharImg = -1 then exit;
    if not AddMid(FCharSet, FCharImg+1, FCharX, FCharY, $10) then exit;
    if FCharIdx = 64 then
      MidImgTable2[MidImgCount2-1].ColorOffset := FColorOffset
    else
      MidImgTable1[MidImgCount1-1].ColorOffset := FColorOffset;
  end;
  end;

end;

procedure DrawObjs;
var
  ctr: Integer;
begin
  //c'est en ralit plus compliqu que a...
  for ctr := 0 to ObjCount - 1 do
    DrawObj(ctr);
end;

procedure ClearObjTable;
begin
  ObjCount := 0;
end;

end.
