unit uScreen;

interface

procedure CreateBackBuffer;
procedure DestroyBackBuffer;

implementation

uses uGlobals;

procedure CreateBackBuffer;
begin
BackBuffer.Pitch := 510;
BackBuffer.Height := 365;
BackBuffer.Width := 510;
GetMem(BackBuffer.Buffer, BackBuffer.Pitch * BackBuffer.Height);
GetMem(BackBuffer.SecondBuffer, BackBuffer.Pitch * BackBuffer.Height);
backbuffer.SecondOffset := backbuffer.SecondBuffer;
backbuffer.secondvalue := $FF;
BackBuffer.Rect.Left := 0;
BackBuffer.Rect.Top := 0;
BackBuffer.Rect.Right := 510;
BackBuffer.Rect.Bottom := 365;
BackBuffer.ClipRect := BackBuffer.Rect;

end;

procedure DestroyBackBuffer;
begin
  FreeMem(BackBuffer.Buffer);
  FreeMem(BackBuffer.SecondBuffer);
  BackBuffer.Pitch := 0;
  BackBuffer.Width := 0;
  BackBuffer.Height := 0;
end;

end.
