unit uSwapper;

interface

function Swap4(original:cardinal):cardinal; overload;
function Swap4(original:integer):integer; overload;
function Swap2(original:word):word; overload;
function Swap2(original:smallint):smallint; overload;


implementation

function Swap4(original:cardinal):cardinal;
asm
  push ebx
  mov bx, ax
  shr eax, 16
  xchg bl, bh
  xchg al, ah
  shl ebx, 16
  or ebx, eax
  mov Result, ebx
  pop ebx
end;

function Swap4(original:integer):integer;
asm
  push ebx
  mov bx, ax
  shr eax, 16
  xchg bl, bh
  xchg al, ah
  shl ebx, 16
  or ebx, eax
  mov Result, ebx
  pop ebx
end;

function Swap2(original:word):word; overload;
asm
  xchg ah, al
end;

function Swap2(original:smallint):smallint; overload;
asm
  xchg ah, al
end;


end.
